<?php
  include("config.php");

  $userid = $_SERVER["PHP_AUTH_USER"];
  // Tachtler
  // default: $db     = pg_connect("host=$DBHOST dbname=$DBNAME user=$DBUSER password=$DBPASS");
  $db = mysql_connect($DBHOST,$DBUSER,$DBPASS);
  mysql_select_db($DBNAME);
?>
<h2>Quarantine management</h2>
<div class="comment">
  Below you see a list of all mails targeted to one of your email addresses and moved to quarantine
  according to your mail filter policy configuration.<br/>
  The "status" column shows two values. The first one indicates the reason why this mail has been quarantined:
  <ul>
    <li><span style="text-decoration:underline;">V</span> - mail is infected by a virus.</li>
    <li><span style="text-decoration:underline;">B</span> - mail has an attachment declared as "banned file" type.</li>
    <li><span style="text-decoration:underline;">S</span> - mail has been declared as "spam".</li>
    <li><span style="text-decoration:underline;">s</span> - mail has been declared as "spammy" (currently not used).</li>
    <li><span style="text-decoration:underline;">M</span> - mail contains a bad MIME header (currently not used).</li>
    <li><span style="text-decoration:underline;">H</span> - mail contains a bad header (currently not used).</li>
    <li><span style="text-decoration:underline;">O</span> - mail is too large (currently not used).</li>
  </ul>
  The second value in the status column indicated the current status of this email:
  <ul>
    <li><span style="text-decoration:underline;">Q</span> (quarantined) - mail has not been delivered to the final recipient,
        but is stored in quarantine.</li>
    <li><span style="text-decoration:underline;">P</span> (passed) - mail is stored in quarantine, but has simultaneously been delivered to the final recipient,<br/>
        because both options "<em>Store mail in quarantine</em>" and "<em>Deliver mail to final recipient</em>" are enabled in the mail filter policy.</li>
    <li><span style="text-decoration:underline;">R</span> (released) - mail has been released manually from quarantine to be sent to the final recipient.</li>
    <li><span style="text-decoration:underline;">D</span> (deleted) - mail has been deleted from quarantine (you will never see these entries).</li>
  </ul>
  When you move your mouse over the first or second value in the status column you will see a small popup with a short explanation.
  <br/><br/>
</div>
<hr/>

<table>
  <tr>
    <td>&nbsp;</td>
    <td><b>Status</b></td>
    <td><b class="link" onclick="loadQuarantine('sender, m.time_num desc')">Sender</b></td>
    <td><b class="link" onclick="loadQuarantine('recipient, m.time_num desc')">Recipient</b></td>
    <td><b class="link" onclick="loadQuarantine('lower(m.subject), m.time_num desc')">Mail Headers</b></td>
    <td><b class="link" onclick="loadQuarantine('m.time_num desc')">Time</b></td>
  </tr>

  <?php
  $columns = "m.mail_id, m.time_iso, mas.email as sender, m.client_addr, m.size, m.content, m.quar_loc, m.spam_level, m.from_addr, m.subject, mar.email as recipient, r.ds, r.rs, r.bl, r.wl, r.bspam_level";
  $order   = $_REQUEST["order"];

  // Tachtler
  // default: $results = pg_query($db, "SELECT * FROM adminusers WHERE userid='" . $userid . "'");
  $results = mysql_query("SELECT * FROM adminusers WHERE userid='" . $userid . "'");
  // Tachtler
  // default: $isadmin = pg_num_rows($results)!=0;
  $isadmin = mysql_num_rows($results)!=0;
  // Tachtler
  // default: pg_free_result($results);
  mysql_free_result($results);

  if ($isadmin) {
    $userrestriction = "TRUE";
  } else {
    $userrestriction = "ua.userid='". $userid ."'";
  }

  // Tachtler
  // default: $results = pg_query($db, "SELECT $columns 
  $results = mysql_query("SELECT $columns 
                              FROM msgs m 
			           INNER JOIN msgrcpt r 
			           ON m.mail_id=r.mail_id 
			      
			           INNER JOIN maddr mas 
			           ON m.sid=mas.id 
			      
			           INNER JOIN maddr mar 
			           ON r.rid=mar.id 

				   INNER JOIN users u
				   ON mar.email=u.email

				   INNER JOIN userauth ua
				   ON ua.email_id=u.id
			      WHERE m.quar_type IN ('F','Z')
			        AND r.rs!='D'
			        AND $userrestriction
			      ORDER BY $order");
  // Tachtler
  // default: $l = pg_num_rows($results);
  $l = mysql_num_rows($results);
  for ($i=0; $i<$l; $i++) {
    // Tachtler
    // default: $row    = pg_fetch_assoc($results);
    $row    = mysql_fetch_assoc($results);
    $mailid = $row["mail_id"];

    $rs = $row["rs"];
    $ds = $row["ds"];
    if ($rs==" " && $ds=="P") {
      // release-state is normally " " (on-hold), "R" (released) or "D" (deleted)
      // if a message is on-hole (" "), but mail is delivered to final recipient
      // (ds=="P"), the release-state will be renamed to "R" (released)
      $rs = "P";
    }
    if ($rs==" ") {
      $rs = "Q";
    }
    $rstxt = array("Q" => "quarantined",
                   "P" => "quarantined and delivered to final recipient",
		   "R" => "released from quarantine to final recipient",
		   "D" => "deleted from quarantine"
		  );

    $content = $row["content"];
    $contenttxt = array("V" => "virus infected",
                        "B" => "banned files attachment",
			"S" => "spam",
			"s" => "spammy",
			"M" => "bad mime header",
			"H" => "bad header",
			"O" => "oversized",
			"C" => "clean"
		       );

    ?>
    <tr>
      <td><input type="checkbox" name="mark_<?php echo $mailid; ?>" id="mark_<?php echo $mailid; ?>"/></td>
      <td>
        <span title="<?php echo $contenttxt[$content]; ?>"><?php echo $content; ?></span>
        /
        <span title="<?php echo $rstxt[$rs]; ?>"><?php echo $rs; ?></span>
      </td>
      <td><?php echo $row["sender"]; ?></td>
      <td><?php echo $row["recipient"]; ?></td>
      <td>
        <span title="<?php echo $row["subject"]; ?>">Subject: <?php echo substr($row["subject"],0,50); ?></span><br/>
	From: <?php echo $row["from_addr"]; ?><br/>
	Size: <?php echo $row["size"]; ?>
      </td>
      <td><?php echo $row["time_iso"]; ?></td>
    </tr>
    <?php
  }
  // Tachtler
  // default: pg_free_result($results);
  mysql_free_result($results);
  ?>
</table>

<input type="button" value="Release selected" onclick="releaseQuarantined()"/>
<input type="button" value="Delete selected" onclick="deleteQuarantined()"/>
<input type="button" value="Back to startpage" onclick="restart()"/>

<div id="waitWorking">&nbsp;</div>

<?php
  // Tachtler
  // default: pg_close($db);
  mysql_close($db);
?>
