<div id="container_virus"><table>
  <tr id="row_virus_comment" class="enabled"><td colspan="3" class="comment">
    An incoming mail will normally be scanned for viruses.<br/>
    Depending on the result of this scan you can decide what to do with virus infected mails.<br/>
    Non-infected mails will automatically given to the next check (banned files by default).<br/>
    Infected mail can optionally be discarded or delivered to the final recipient.<br/><br/>
    You are highly encouraged to enable virus checking. The most sensible configuration includes<br/>
    quarantining virus infected mails to file system, no delivery of infected mails to the final recipient,<br/>
    but activating notification mails to the final recipient so that the final recipient can ask the<br/>
    mail administrator to manually release a mail from quarantine if needed.
    <br/><br/><hr/>
  </td></tr>

  <tr id="row_virus_enabled" class="enabled"><td><b>Virus checks enabled:</b></td>
    <td><select name="virus_enabled" id="virus_enabled" size="1" onchange="updateFormVirus()">
      <option value="1" <?php echo ($data["bypass_virus_checks"]=="N")?"selected=\"selected\"":""; ?>>Yes</option>
      <option value="0" <?php echo ($data["bypass_virus_checks"]=="Y")?"selected=\"selected\"":""; ?>>No</option>
    </select></td>
    <td class="comment">When disabled absolutely no virus checking will be done to your emails.</td>
  </tr>
  <tr id="row_virus_quarantine"><td><b>Store infected mails in quarantine:</b></td>
    <td><select name="virus_quarantine" id="virus_quarantine" size="1" onchange="updateFormVirus()">
      <option value="1" <?php echo ( $data["virus_quarantine_to"])?"selected=\"selected\"":""; ?>>Yes</option>
      <option value="0" <?php echo (!$data["virus_quarantine_to"])?"selected=\"selected\"":""; ?>>No</option>
    </select></td>
    <td class="comment">When you enable this option, an infected mail can be stored in a quarantine or sent to a special
      email address. This is most useful when you disable <em>"Deliver virus infected mails to final recipient"</em>,
      so virus infected mails will not be lost.
    </td>
  </tr>
  <tr id="row_virus_quarantine_to"><td><b>Where to quarantine viruses:</b></td>
    <td><select name="virus_quarantine_to" id="virus_quarantine_to" size="1" onchange="updateFormVirus()">
      <option value="email" <?php echo (!strpos($data["virus_quarantine_to"],"@")===false)?"selected=\"selected\"":""; ?>>Send email</option>
      <option value="file"  <?php echo ( strpos($data["virus_quarantine_to"],"@")===false)?"selected=\"selected\"":""; ?>>Save as file</option>
    </select></td>
    <td class="comment">You can choose between storing virus infected mails in a special directory on the mailserver (<em>"Save as file"</em>)
      or send it via email to another email address ("<em>Send email</em>"). If you choose to send an email, make sure this recipient
      accepts virus infected mails! You could configure a special email address for this with "<em>Virus checks enabled</em>" set to "<em>No</em>".<br/>
      The directory where infected mails will be quarantined if you choose "<em>Save as file</em>" can NOT be configured on a per user basis,
      so dont ask ;-)
    </td>
  </tr>
  <tr id="row_virus_quarantine_email"><td><b>Email address for virus quarantine:</b></td>
    <td><input type="text" id="virus_quarantine_email" name="virus_quarantine_email" value="<?php echo (strpos($data["virus_quarantine_to"],"@")===false)?"":$data["virus_quarantine_to"]; ?>" size="20"/></td>
    <td class="comment">The email address where virus infected mails have to be sent to.</td>
  </tr>
  <tr id="row_virus_notify_admin"><td><b>Send virus notification to admin:</b></td>
    <td><select name="virus_notify_admin" id="virus_notify_admin" size="1" onchange="updateFormVirus()">
      <option value="1" <?php echo ( $data["virus_admin"])?"selected=\"selected\"":""; ?>>Yes</option>
      <option value="0" <?php echo (!$data["virus_admin"])?"selected=\"selected\"":""; ?>>No</option>
    </select></td>
    <td class="comment">When a virus infected mail is detected we can automatically send a notification about this infected mail
      to a special email address (e.g. a postmaster who collects statistics about how often someone receives infected mails). 
      This notification mail contains the sender and recipient of the infected mail, some meta data
      (extracted from the mail headers) and the name of the virus found in the mail.
    </td>
  </tr>
  <tr id="row_virus_notify_admin_email"><td><b>Email address to send virus notifications to:</b></td>
    <td><input type="text" id="virus_notify_admin_email" name="virus_notify_admin_email" value="<?php echo $data["virus_admin"]; ?>" size="20"/></td>
    <td class="comment">The mail address where virus notification emails should be sent to.</td>
  </tr>
  <tr id="row_virus_lover"><td><b>Deliver virus infected mails to final recipient:</b></td>
    <td><select name="virus_lover" id="virus_lover" size="1" onchange="updateFormVirus()">
      <option value="1" <?php echo ($data["virus_lover"]=="Y")?"selected=\"selected\"":""; ?>>Yes</option>
      <option value="0" <?php echo ($data["virus_lover"]=="N")?"selected=\"selected\"":""; ?>>No</option>
    </select></td>
    <td class="comment">When a virus infected mail is detected you can decide whether or not to receive this email. When you set this option to
      "<em>Yes</em>" you will receive the mail (for security reasons the mail will be wrapped by a special "container mail" telling you, that
      this mail contains a virus). When you set this to "<em>No</em>", you will NOT receive the infected mail. In this case you should enable
      the option "<em>Store infected mails in quarantine</em>" to prevent you from really loosing mail.
    </td>
  </tr>
  <tr id="row_virus_notify_recpt"><td><b>Inform recipient about virus infected mail in quarantine:</b></td>
    <td><select name="virus_notify_recpt" id="virus_notify_recpt" size="1">
      <option value="1" <?php echo ($data["warnvirusrecip"]=="Y")?"selected=\"selected\"":""; ?>>Yes</option>
      <option value="0" <?php echo ($data["warnvirusrecip"]=="N")?"selected=\"selected\"":""; ?>>No</option>
    </select></td>
    <td class="comment">If you decided not to receive virus infected mails, and if you have enabled the quarantine mechanism,
      you can set this option to "<em>Yes</em>" to receive a notification mail telling you that we received a virus infected
      mail for you which has been moved into quarantine. This notification email will contain a "reference id" for your
      email. If you really want to get this mail, ask your mail administrator to release the mail with this "reference id"
      from the quarantine.<br/>
      <em>TODO: Releasing mail from quarantine does not work until now. Currently the mail administrator has to extract
      the mail manually from the quarantine and send you the quarantine file.</em>
    </td>
  </tr>
  <tr id="row_virus_addr_extension"><td><b>Add recipient address extension for virus infected mails:</b></td>
    <td><select name="virus_addr_extension" id="virus_addr_extension" size="1" onchange="updateFormVirus()">
      <option value="1" <?php echo ( $data["addr_extension_virus"])?"selected=\"selected\"":""; ?>>Yes</option>
      <option value="0" <?php echo (!$data["addr_extension_virus"])?"selected=\"selected\"":""; ?>>No</option>
    </select></td>
    <td class="comment">If you decided to receive virus infected mails you can automatically modify the recipient address using an "address
      extension". This means, when your email address is "alice@anywhere.com", and you enable this feature and set "<em>Address extension to
      be used</em>" (see below) to "virus", the final recipient will be "alice+virus@anywhere.com". <br/>
      One special advantage of this: if you have an IMAP account on this mail server, and if you have an IMAP folder called "virus"
      below your INBOX, this extension mechanism will make the email automatically to be stored in this "virus" folder
      (i.e. no need to use SIEVE for this).<br/>
      If this does not work for you, please contact your mail administrator - it's probably a permission problem (missing "anyone p" permission).<br/>
      <em>TODO: verify if this really works!</em>
    </td>
  </tr>
  <tr id="row_virus_addr_extension_txt"><td><b>Address extension to be used:</b></td>
    <td><input type="text" id="virus_addr_extension_txt" name="virus_addr_extension_txt" value="<?php echo $data["addr_extension_virus"]; ?>" size="10"/></td>
    <td class="comment">The address extension to be used for receiving virus infected mails. For users with an own IMAP account on this mail
      server this causes the mail system to store the received mail in the IMAP folder with the same name as the address extension given here.
    </td>
  </tr>
</table></div>
