
function ajaxfill(elemId,url,waitId,waitText,postFunction) {
  var waitElem = null;
  if (waitId) {
    waitElem = document.getElementById(waitId);
    if (waitText) {
      waitElem.innerHTML = waitText;
    } else {
      waitElem.innerHTML = "&nbsp;";
    }
  }

  var xmlHttp = false;
  if (typeof XMLHttpRequest != 'undefined') {
    xmlHttp = new XMLHttpRequest();
  }
  if (!xmlHttp) {
    try {
      xmlHttp  = new ActiveXObject("Msxml2.XMLHTTP");
    } catch(e) {
      try {
        xmlHttp  = new ActiveXObject("Microsoft.XMLHTTP");
      } catch(e) {
        xmlHttp  = false;
      }
    }
  }

  if (xmlHttp) {
    xmlHttp.onreadystatechange = function () {
      if (xmlHttp.readyState == 4) {
        var content = xmlHttp.responseText;

	if (waitElem) {
	  waitElem.innerHTML = "&nbsp;";
	}

        if (elemId) {
          var elem = document.getElementById(elemId);
          elem.innerHTML = content;
        }

        if (postFunction) {
          postFunction(elemId,url,content);
        }
      }
    };
    xmlHttp.open('GET', url, true);
    xmlHttp.send(null);
  } else {
    alert("Browser does not support AJAX");
  }
}

function showForm(name) {
  var sections = Array("virus", "spam", "banned", "badheader");
  var l = sections.length;
  for (i=0; i<l; i++) {
    var s       = sections[i];
    var display = (s==name?"block":"none");
    var font    = (s==name?"bold":"normal");

    document.getElementById("container_"+s).style.display = display;
    document.getElementById("button_"+s).style.fontWeight = font;
  }
}

function initForms(elemId,url,content) {
  updateFormVirus();
  updateFormSpam();
  updateFormBanned();
  updateFormBadHeader();

  showForm("virus");
}

function loadConfig(policy_id) {
  ajaxfill("mainform", "loadConfig.php?policy_id="+policy_id, "mainform", "Please wait while loading configuration...", initForms);
}

function updateFormVirus() {
  var row_enabled = document.getElementById("row_virus_enabled");
  var row_quarantine = document.getElementById("row_virus_quarantine");
  var row_quarantine_to = document.getElementById("row_virus_quarantine_to");
  var row_quarantine_email = document.getElementById("row_virus_quarantine_email");
  var row_notify_admin = document.getElementById("row_virus_notify_admin");
  var row_notify_admin_email = document.getElementById("row_virus_notify_admin_email");
  var row_virus_lover = document.getElementById("row_virus_lover");
  var row_notify_recpt = document.getElementById("row_virus_notify_recpt");
  var row_addr_extension = document.getElementById("row_virus_addr_extension");
  var row_addr_extension_txt = document.getElementById("row_virus_addr_extension_txt");

  var elem_enabled = document.getElementById("virus_enabled");
  var elem_quarantine = document.getElementById("virus_quarantine");
  var elem_quarantine_to = document.getElementById("virus_quarantine_to");
  var elem_quarantine_email = document.getElementById("virus_quarantine_email");
  var elem_notify_admin = document.getElementById("virus_notify_admin");
  var elem_notify_admin_email = document.getElementById("virus_notify_admin_email");
  var elem_virus_lover = document.getElementById("virus_lover");
  var elem_notify_recpt = document.getElementById("virus_notify_recpt");
  var elem_addr_extension = document.getElementById("virus_addr_extension");
  var elem_addr_extension_txt = document.getElementById("virus_addr_extension_txt");

  var virus_enabled = elem_enabled.value;
  if (virus_enabled=="0") {
    row_quarantine.className="disabled";
    row_quarantine_to.className="disabled";
    row_quarantine_email.className="disabled";
    row_notify_admin.className="disabled";
    row_notify_admin_email.className="disabled";
    row_virus_lover.className="disabled";
    row_notify_recpt.className="disabled";
    row_addr_extension.className="disabled";
    row_addr_extension_txt.className="disabled";

    elem_quarantine.disabled="disabled";
    elem_quarantine_to.disabled="disabled";
    elem_quarantine_email.disabled="disabled";
    elem_notify_admin.disabled="disabled";
    elem_notify_admin_email.disabled="disabled";
    elem_virus_lover.disabled="disabled";
    elem_notify_recpt.disabled="disabled";
    elem_addr_extension.disabled="disabled";
    elem_addr_extension_txt.disabled="disabled";

    return;
  }

  row_quarantine.className = "enabled";
  elem_quarantine.disabled = "";

  var quarantine = elem_quarantine.value;
  if (quarantine=="0") {
    row_quarantine_to.className="disabled";
    row_quarantine_email.className="disabled"; 
    elem_quarantine_to.disabled="disabled";
    elem_quarantine_email.disabled="disabled";
  } else {
    row_quarantine_to.className="enabled";
    elem_quarantine_to.disabled="";

    var quarantine_to = elem_quarantine_to.value;
    if (quarantine_to=="email") {
      row_quarantine_email.className="enabled";
      elem_quarantine_email.disabled="";
    } else {
      row_quarantine_email.className="disabled";
      elem_quarantine_email.disabled="disabled";
    }
  }

  row_notify_admin.className = "enabled";
  elem_notify_admin.disabled = "";

  var notify_admin = elem_notify_admin.value;
  if (notify_admin=="0") {
    row_notify_admin_email.className = "disabled";
    elem_notify_admin_email.disabled = "disabled";
  } else {
    row_notify_admin_email.className = "enabled";
    elem_notify_admin_email.disabled = "";
  }

  row_virus_lover.className = "enabled";
  elem_virus_lover.disabled = "";

  var virus_lover = elem_virus_lover.value;
  if (virus_lover=="0" && quarantine=="1") {
    row_notify_recpt.className = "enabled";
    elem_notify_recpt.disabled = "";
  } else {
    row_notify_recpt.className = "disabled";
    elem_notify_recpt.disabled = "disabled";
  }

  if (virus_lover=="1") {
    row_addr_extension.className = "enabled";
    elem_addr_extension.disabled = "";

    var addr_extension = elem_addr_extension.value;
    if (addr_extension=="0") {
      row_addr_extension_txt.className = "disabled";
      elem_addr_extension_txt.disabled = "disabled";
    } else {
      row_addr_extension_txt.className = "enabled";
      elem_addr_extension_txt.disabled = "";
    }
  } else {
    row_addr_extension.className = "disabled";
    row_addr_extension_txt.className = "disabled";
    elem_addr_extension.disabled = "disabled";
    elem_addr_extension_txt.disabled = "disabled";
  }
}

function updateFormBanned() {
  var row_enabled = document.getElementById("row_banned_enabled");
  var row_quarantine = document.getElementById("row_banned_quarantine");
  var row_quarantine_to = document.getElementById("row_banned_quarantine_to");
  var row_quarantine_email = document.getElementById("row_banned_quarantine_email");
  var row_notify_admin = document.getElementById("row_banned_notify_admin");
  var row_notify_admin_email = document.getElementById("row_banned_notify_admin_email");
  var row_banned_lover = document.getElementById("row_banned_lover");
  var row_notify_recpt = document.getElementById("row_banned_notify_recpt");
  var row_addr_extension = document.getElementById("row_banned_addr_extension");
  var row_addr_extension_txt = document.getElementById("row_banned_addr_extension_txt");

  var elem_enabled = document.getElementById("banned_enabled");
  var elem_quarantine = document.getElementById("banned_quarantine");
  var elem_quarantine_to = document.getElementById("banned_quarantine_to");
  var elem_quarantine_email = document.getElementById("banned_quarantine_email");
  var elem_notify_admin = document.getElementById("banned_notify_admin");
  var elem_notify_admin_email = document.getElementById("banned_notify_admin_email");
  var elem_banned_lover = document.getElementById("banned_lover");
  var elem_notify_recpt = document.getElementById("banned_notify_recpt");
  var elem_addr_extension = document.getElementById("banned_addr_extension");
  var elem_addr_extension_txt = document.getElementById("banned_addr_extension_txt");

  var banned_enabled = elem_enabled.value;
  if (banned_enabled=="0") {
    row_quarantine.className="disabled";
    row_quarantine_to.className="disabled";
    row_quarantine_email.className="disabled";
    row_notify_admin.className="disabled";
    row_notify_admin_email.className="disabled";
    row_banned_lover.className="disabled";
    row_notify_recpt.className="disabled";
    row_addr_extension.className="disabled";
    row_addr_extension_txt.className="disabled";

    elem_quarantine.disabled="disabled";
    elem_quarantine_to.disabled="disabled";
    elem_quarantine_email.disabled="disabled";
    elem_notify_admin.disabled="disabled";
    elem_notify_admin_email.disabled="disabled";
    elem_banned_lover.disabled="disabled";
    elem_notify_recpt.disabled="disabled";
    elem_addr_extension.disabled="disabled";
    elem_addr_extension_txt.disabled="disabled";

    return;
  }

  row_quarantine.className = "enabled";
  elem_quarantine.disabled = "";

  var quarantine = elem_quarantine.value;
  if (quarantine=="0") {
    row_quarantine_to.className="disabled";
    row_quarantine_email.className="disabled"; 
    elem_quarantine_to.disabled="disabled";
    elem_quarantine_email.disabled="disabled";
  } else {
    row_quarantine_to.className="enabled";
    elem_quarantine_to.disabled="";

    var quarantine_to = elem_quarantine_to.value;
    if (quarantine_to=="email") {
      row_quarantine_email.className="enabled";
      elem_quarantine_email.disabled="";
    } else {
      row_quarantine_email.className="disabled";
      elem_quarantine_email.disabled="disabled";
    }
  }

  row_notify_admin.className = "enabled";
  elem_notify_admin.disabled = "";

  var notify_admin = elem_notify_admin.value;
  if (notify_admin=="0") {
    row_notify_admin_email.className = "disabled";
    elem_notify_admin_email.disabled = "disabled";
  } else {
    row_notify_admin_email.className = "enabled";
    elem_notify_admin_email.disabled = "";
  }

  row_banned_lover.className = "enabled";
  elem_banned_lover.disabled = "";

  var banned_lover = elem_banned_lover.value;
  if (banned_lover=="0" && quarantine=="1") {
    row_notify_recpt.className = "enabled";
    elem_notify_recpt.disabled = "";
  } else {
    row_notify_recpt.className = "disabled";
    elem_notify_recpt.disabled = "disabled";
  }

  if (banned_lover=="1") {
    row_addr_extension.className = "enabled";
    elem_addr_extension.disabled = "";

    var addr_extension = elem_addr_extension.value;
    if (addr_extension=="0") {
      row_addr_extension_txt.className = "disabled";
      elem_addr_extension_txt.disabled = "disabled";
    } else {
      row_addr_extension_txt.className = "enabled";
      elem_addr_extension_txt.disabled = "";
    }
  } else {
    row_addr_extension.className = "disabled";
    row_addr_extension_txt.className = "disabled";
    elem_addr_extension.disabled = "disabled";
    elem_addr_extension_txt.disabled = "disabled";
  }
}

function updateFormSpam() {
  var row_enabled = document.getElementById("row_spam_enabled");
  var row_spamlevel = document.getElementById("row_spam_spamlevel");
  var row_quarantine = document.getElementById("row_spam_quarantine");
  var row_quarantine_to = document.getElementById("row_spam_quarantine_to");
  var row_quarantine_email = document.getElementById("row_spam_quarantine_email");
  var row_notify_admin = document.getElementById("row_spam_notify_admin");
  var row_notify_admin_email = document.getElementById("row_spam_notify_admin_email");
  var row_spam_lover = document.getElementById("row_spam_lover");
  var row_addr_extension = document.getElementById("row_spam_addr_extension");
  var row_addr_extension_txt = document.getElementById("row_spam_addr_extension_txt");

  var elem_enabled = document.getElementById("spam_enabled");
  var elem_spamlevel = document.getElementById("spam_spamlevel");
  var elem_quarantine = document.getElementById("spam_quarantine");
  var elem_quarantine_to = document.getElementById("spam_quarantine_to");
  var elem_quarantine_email = document.getElementById("spam_quarantine_email");
  var elem_notify_admin = document.getElementById("spam_notify_admin");
  var elem_notify_admin_email = document.getElementById("spam_notify_admin_email");
  var elem_spam_lover = document.getElementById("spam_lover");
  var elem_addr_extension = document.getElementById("spam_addr_extension");
  var elem_addr_extension_txt = document.getElementById("spam_addr_extension_txt");

  var spam_enabled = elem_enabled.value;
  if (spam_enabled=="0") {
    row_spamlevel.className="disabled";
    row_quarantine.className="disabled";
    row_quarantine_to.className="disabled";
    row_quarantine_email.className="disabled";
    row_notify_admin.className="disabled";
    row_notify_admin_email.className="disabled";
    row_spam_lover.className="disabled";
    row_addr_extension.className="disabled";
    row_addr_extension_txt.className="disabled";

    elem_spamlevel.disabled="disabled";
    elem_quarantine.disabled="disabled";
    elem_quarantine_to.disabled="disabled";
    elem_quarantine_email.disabled="disabled";
    elem_notify_admin.disabled="disabled";
    elem_notify_admin_email.disabled="disabled";
    elem_spam_lover.disabled="disabled";
    elem_addr_extension.disabled="disabled";
    elem_addr_extension_txt.disabled="disabled";

    return;
  }

  row_spamlevel.className = "enabled";
  elem_spamlevel.disabled = "";

  row_quarantine.className = "enabled";
  elem_quarantine.disabled = "";

  var quarantine = elem_quarantine.value;
  if (quarantine=="0") {
    row_quarantine_to.className="disabled";
    row_quarantine_email.className="disabled"; 
    elem_quarantine_to.disabled="disabled";
    elem_quarantine_email.disabled="disabled";
  } else {
    row_quarantine_to.className="enabled";
    elem_quarantine_to.disabled="";

    var quarantine_to = elem_quarantine_to.value;
    if (quarantine_to=="email") {
      row_quarantine_email.className="enabled";
      elem_quarantine_email.disabled="";
    } else {
      row_quarantine_email.className="disabled";
      elem_quarantine_email.disabled="disabled";
    }
  }

  row_notify_admin.className = "enabled";
  elem_notify_admin.disabled = "";

  var notify_admin = elem_notify_admin.value;
  if (notify_admin=="0") {
    row_notify_admin_email.className = "disabled";
    elem_notify_admin_email.disabled = "disabled";
  } else {
    row_notify_admin_email.className = "enabled";
    elem_notify_admin_email.disabled = "";
  }

  row_spam_lover.className = "enabled";
  elem_spam_lover.disabled = "";

  var spam_lover = elem_spam_lover.value;

  if (spam_lover=="1") {
    row_addr_extension.className = "enabled";
    elem_addr_extension.disabled = "";

    var addr_extension = elem_addr_extension.value;
    if (addr_extension=="0") {
      row_addr_extension_txt.className = "disabled";
      elem_addr_extension_txt.disabled = "disabled";
    } else {
      row_addr_extension_txt.className = "enabled";
      elem_addr_extension_txt.disabled = "";
    }
  } else {
    row_addr_extension.className = "disabled";
    row_addr_extension_txt.className = "disabled";
    elem_addr_extension.disabled = "disabled";
    elem_addr_extension_txt.disabled = "disabled";
  }
}

function updateFormBadHeader() {
}

function emailClick() {
  var mailaddr = document.getElementById("mailaddr");
  var wblist   = document.getElementById("whiteblack");
  var save     = document.getElementById("save");
  var policy   = document.getElementById("policy");
  var e        = document.getElementById("edit");
  var d        = document.getElementById("delete");

  if (mailaddr.selectedIndex==-1) {
    wblist.className = "disabled";
    wblist.disabled = "disabled";
    save.className = "disabled";
    save.disabled = "disabled";
    policy.selectedIndex = -1;
    e.className = "disabled";
    e.disabled = "disabled";
    d.className = "disabled";
    d.disabled = "disabled";
    return;
  }

  wblist.className = "enabled";
  wblist.disabled  = "";

  var id = mailaddr.value;
  ajaxfill(null, "getPolicyByEmailId.php?email_id="+id, "waitAssign", "Please wait...", updateSelectedPolicy);
}

function updateSelectedPolicy(elemId, url, content) {
  var save     = document.getElementById("save");
  var policy   = document.getElementById("policy");
  var e        = document.getElementById("edit");
  var d        = document.getElementById("delete");

  policy.value = content;

  save.className = "enabled";
  save.disabled  = "";

  e.className = "enabled";
  e.disabled = "";
  d.className = "enabled";
  d.disabled = "";
}

function policyClick() {
  var policy   = document.getElementById("policy");
  var e        = document.getElementById("edit");
  var d        = document.getElementById("delete");

  if (policy.selectedIndex==-1) {
    e.className = "disabled";
    e.disabled = "disabled";
    d.className = "disabled";
    d.disabled = "disabled";
  } else {
    e.className = "enabled";
    e.disabled = "";
    d.className = "enabled";
    d.disabled = "";
  }
}

function editPolicy() {
  var policy = document.getElementById("policy");
  loadConfig(policy.value);
}

function restart() {
  ajaxfill("mainform", "loadMainForm.php", "mainform", "Please wait while loading form...", null);
}

function savePolicy(policy_id) {
  var query = "policy_id=" + policy_id;

  var elems1 = document.getElementsByTagName("input");
  var elems2 = document.getElementsByTagName("select");
  var l1     = elems1.length;
  var l2     = elems2.length;
  var l      = l1+l2;
  var i;
  for (i=0; i<l; i++) {
    var elem;
    if (i<l1) {
      elem = elems1[i];
    } else {
      elem = elems2[i-l1]
    }

    if (elem.getAttribute("type") == "button") {
      continue;
    }

    var name = elem.name;
    var value = encodeURIComponent(elem.value);
    query = query + "&" + name + "=" + value;
  }

  ajaxfill(null, "savePolicy.php?"+query, "waitSave", "Please wait...", savePolicy2);
}

function savePolicy2(elemId, url, content) {
  alert(content);
}

function newPolicy() {
  var name = window.prompt("Name of new policy");
  if (name) {
    name = encodeURIComponent(name);
    ajaxfill(null, "newPolicy.php?policy_name="+name, "waitAssign", "Please wait...", newPolicy2);
  }
}

function newPolicy2(elemId, url, content) {
  window.location.reload();
}

function savePolicyAssignment() {
  var email_id  = document.getElementById("mailaddr").value;
  var policy_id = document.getElementById("policy").value;

  if (email_id && policy_id) {
    ajaxfill(null, "savePolicyAssignment.php?email_id="+email_id+"&policy_id="+policy_id, "waitAssign", "Please wait...", savePolicyAssignment2);
  }
}

function savePolicyAssignment2(elemId, url, content) {
  alert(content);
}

function deletePolicy() {
  alert("Deleting policies not yet implemented");
}

function editWBList() {
  var email_id = document.getElementById("mailaddr").value;
  loadWBList(email_id);
}

function loadWBList(email_id) {
  ajaxfill("mainform", "loadWBList.php?email_id="+email_id, "mainform", "Please wait while loading form...", null);
}

function validateWB(id) {
  var elem = document.getElementById(id);
  var value = elem.value;
  var save = document.getElementById("save");

  if (value=='w' || value=='W') {
    elem.value='W';
    save.className = "enabled";
    save.disabled = "";
    return;
  }

  if (value=='b' || value=='B') {
    elem.value='B';
    save.className = "enabled";
    save.disabled = "";
    return;
  }

  value = parseFloat(value.replace(/,/, "."));
  if (isNaN(value)) {
    alert("Invalid score value (W, B or a float value)");
    save.className = "disabled";
    save.disabled = "disabled";
  } else {
    elem.value = value;
    save.className = "enabled";
    save.disabled = "";
  }
}

function deleteWBEntries() {
  var elems = document.getElementsByTagName("input");
  var l = elems.length;
  var i;
  var sids = "";

  for (i=0; i<l; i++) {
    var elem = elems[i];
    var id = elem.id;

    if (id.indexOf("del_") != 0) {
      continue
    }
    if (!elem.checked) {
      continue;
    }

    var sid = id.substr(4);
    sids = sids + "+" + sid;
  }

  if (sids != "") {
    var elem = document.getElementById("email_id");
    var eid = elem.value;

    ajaxfill(null, "deleteWBEntries.php?email_id=" + eid + "&sids=" + sids, "waitWorking", "Please wait...", deleteWBEntries2);
  } else {
    alert("no entries selected");
  }
}

function deleteWBEntries2(elemId, url, content) {
  alert(content);

  var elem = document.getElementById("email_id");
  var eid = elem.value;
  loadWBList(eid);
}

function updateWBEntries() {
  var elem = document.getElementById("email_id");
  var eid  = elem.value;

  var query = "email_id=" + eid;

  var elems = document.getElementsByTagName("input");
  var l = elems.length;
  var i;

  for (i=0; i<l; i++) {
    var elem = elems[i];
    var id   = elem.id;

    if (id.indexOf("wb_") != 0) {
      continue
    }

    var value = elem.value;
    query = query + "&" + id + "=" + encodeURIComponent(value);
  }

  var newsender = document.getElementById("newemail");
  var newwb     = document.getElementById("newwb");
  query = query + "&newemail=" + encodeURIComponent(newsender.value);
  query = query + "&newwb=" + encodeURIComponent(newwb.value);

  ajaxfill(null, "updateWBEntries.php?" + query, "waitWorking", "Please wait...", updateWBEntries2);
}

function updateWBEntries2(elemId, url, content) {
  alert(content);

  var elem = document.getElementById("email_id");
  var eid = elem.value;
  loadWBList(eid);
}

function loadQuarantine(order) {
  ajaxfill("mainform", "loadQuarantine.php?order=" + encodeURIComponent(order), "mainform", "Please wait while loading quarantine data...", null);
}

function releaseQuarantined() {
  var ids = "";
  var elems = document.getElementsByTagName("input");
  var l = elems.length;
  var i;

  for (i=0; i<l; i++) {
    var elem = elems[i];
    var id   = elem.id;

    if (id.indexOf("mark_") != 0) {
      continue
    }
    if (!elem.checked) {
      continue;
    }

    var mailid = id.substr(5);
    ids = ids + " " + mailid;
  }

  if (ids != "") {
    ajaxfill(null, "releaseQuarantined.php?mailids=" + encodeURIComponent(ids), "waitWorking", "Please wait...", releaseQuarantined2);
  } else {
    alert("No mails selected.");
  }
}

function releaseQuarantined2(elemId, url, content) {
  alert(content);
  loadQuarantine('m.time_num desc');
}

function deleteQuarantined() {
  var ids = "";
  var elems = document.getElementsByTagName("input");
  var l = elems.length;
  var i;

  for (i=0; i<l; i++) {
    var elem = elems[i];
    var id   = elem.id;

    if (id.indexOf("mark_") != 0) {
      continue
    }
    if (!elem.checked) {
      continue;
    }

    var mailid = id.substr(5);
    ids = ids + " " + mailid;
  }

  if (ids != "") {
    ajaxfill(null, "deleteQuarantined.php?mailids=" + encodeURIComponent(ids), "waitWorking", "Please wait...", deleteQuarantined2);
  } else {
    alert("No mails selected.");
  }
}

function deleteQuarantined2(elemId, url, content) {
  alert(content);
  loadQuarantine('m.time_num desc');
}

function openReportForm() {
  ajaxfill("mainform", "loadReportForm.php", "mainform", "Please wait while loading form...", null);
}

function submitReport() {
  var elem  = document.getElementById("mailheaders");
  var value = elem.value;

  ajaxfill(null, "submitReport.php?mailheaders=" + encodeURIComponent(value), "waitWorking", "Please wait...", submitReport2);
}

function submitReport2(elemId, url, content) {
  alert(content);
  restart();
}

function loadStatistics() {
  ajaxfill("mainform", "loadStatistics.php?tags=&values=", "mainform", "Please wait while calculating statistics - this may take some time...", null);
}

function reloadStatistics(newtag,newvalue) {
  var tags   = "";
  var values = "";

  var tagsElem   = document.getElementById("tags");
  var valuesElem = document.getElementById("values");

  if (tagsElem) {
    tags   = tagsElem.value;
    values = valuesElem.value;
  }

  if (newtag && newvalue) {
    if (tags.length!=0) {
      tags   = tags   + ",";
      values = values + ",";
    }
    tags   = tags   + newtag;
    values = values + newvalue;
  }

  tags   = encodeURIComponent(tags);
  values = encodeURIComponent(values);

  ajaxfill("mainform", "loadStatistics.php?tags="+tags+"&values="+values, "mainform", "Please wait while calculating statistics - this may take some time...", null);
}

function changeUser(userid) {
  window.location.href = "changeUser.php?olduser="+encodeURIComponent(userid);
}

function removeFilter(idx) {
  var tags   = document.getElementById("tags").value.split(",");
  var values = document.getElementById("values").value.split(",");

  tags.splice(idx,1);
  values.splice(idx,1);

  tags   = encodeURIComponent(tags.join(","));
  values = encodeURIComponent(values.join(","));

  ajaxfill("mainform", "loadStatistics.php?tags="+tags+"&values="+values, "mainform", "Please wait while calculating statistics - this may take some time...", null);
}

function fullStatsFor(name) {
  alert("expanding table to display full listing not yet implemented.");
}

